HTTP::Request - Crystal 0.35.1

# class HTTP::Request

- HTTP::Request
- Reference
- Object

##
Overview

An HTTP request.

It serves both to perform requests by an `HTTP::Client` and to represent requests received by an `HTTP::Server`.

A request always holds an `IO` as a body. When creating a request with a `String` or `Bytes` its body will be a `IO::Memory` wrapping these, and the `Content-Length` header will be set appropriately.

##
Defined in:

##
Constructors

- .new(method : String, resource : String, headers : Headers? = nil, body : String | Bytes | IO | Nil = nil, version = "HTTP/1.1")

##
Class Method Summary

- .from_io(io, *, max_request_line_size : Int32 = HTTP::MAX_REQUEST_LINE_SIZE, max_headers_size : Int32 = HTTP::MAX_HEADERS_SIZE) : HTTP::Request | HTTP::Status | Nil

  Returns a `HTTP::Request` instance if successfully parsed, `nil` on EOF or `HTTP::Status` otherwise.

##
Instance Method Summary

- #body : IO?
- #body=(body : Nil)
- #body=(body : IO)
- #body=(body : Bytes)
- #body=(body : String)
- #content_length
- #content_length=(length : Int)
- #cookies

  Returns a convenience wrapper around querying and setting cookie related headers, see `HTTP::Cookies`.

- #headers : Headers
- #headers=(headers : Headers)
- #host

  Returns request host from headers.

- #host_with_port

  Returns request host with port from headers.

- #if_match : Array(String)?
- #if_none_match : Array(String)?
- #ignore_body?
- #keep_alive?
- #method : String
- #method=(method : String)
- #path

  Returns the request's path component.

- #path=(path)

  Sets request's path component.

- #query

  Lazily parses and returns the request's query component.

- #query=(value)

  Sets request's query component.

- #query_params

  Returns a convenience wrapper around querying and setting query params, see `HTTP::Params`.

- #remote_address : RemoteAddressType

  The network address that sent the request to an HTTP server.

- #remote_address=(remote_address : RemoteAddressType)

  The network address that sent the request to an HTTP server.

- #resource
- #to_io(io)
- #version : String
- #version=(version : String)

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(method : String, resource : String, headers : Headers? = nil, body : String | Bytes | IO | Nil = nil, version = "HTTP/1.1") #

##
Class Method Detail

def self.from_io(io, *, max_request_line_size : Int32 = HTTP::MAX_REQUEST_LINE_SIZE, max_headers_size : Int32 = HTTP::MAX_HEADERS_SIZE) : HTTP::Request | HTTP::Status | Nil #

Returns a `HTTP::Request` instance if successfully parsed, `nil` on EOF or `HTTP::Status` otherwise.

##
Instance Method Detail

def body : IO? #
def body=(body : Nil) #
def body=(body : IO) #
def body=(body : Bytes) #
def body=(body : String) #
def content_length #
def content_length=(length : Int) #
def cookies #

Returns a convenience wrapper around querying and setting cookie related headers, see `HTTP::Cookies`.

def headers : Headers #
def headers=(headers : Headers) #
def host #

Returns request host from headers.

def host_with_port #

Returns request host with port from headers.

def if_match : Array(String)? #
def if_none_match : Array(String)? #
def ignore_body? #
def keep_alive? #
def method : String #
def method=(method : String) #
def path #

Returns the request's path component.

def path=(path) #

Sets request's path component.

def query #

Lazily parses and returns the request's query component.

def query=(value) #

Sets request's query component.

def query_params #

Returns a convenience wrapper around querying and setting query params, see `HTTP::Params`.

def remote_address : RemoteAddressType #

The network address that sent the request to an HTTP server.

`HTTP::Server` will try to fill this property, and its value will have a format like "IP:port", but this format is not guaranteed. Middlewares can overwrite this value.

This property is not used by `HTTP::Client`.

def remote_address=(remote_address : RemoteAddressType) #

The network address that sent the request to an HTTP server.

`HTTP::Server` will try to fill this property, and its value will have a format like "IP:port", but this format is not guaranteed. Middlewares can overwrite this value.

This property is not used by `HTTP::Client`.

def resource #
def to_io(io) #
def version : String #
def version=(version : String) #